// -*- c++ -*-
//  Generated by gtkmmproc from ./../app.gen_h -- DO NOT MODIFY!
#ifndef _GNOMEMM_APP_H
#define _GNOMEMM_APP_H

// -*- C++ -*-
/* $Id: app.gen_h,v 1.68 2000/05/05 18:46:24 kenelson Exp $ */

/***************************************************************
WARNING WARNING WARNING WARNING WARNING WARNING WARNING WARNING
****************************************************************
 This file has been subject to rapid changes.  Don't assume
 things will still work.
***************************************************************/

/* app.gen_h, app.h for gnome--
 *
 * Copyright (C) 2000 The Gtk-- Development Team
 * Copyright (C) 1998 EMC Capital Management Inc.
 * Developed by Havoc Pennington <hp@pobox.com>
 *
 * Copyright (C) 1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gnome--/dock.h>
#include <gnome--/dialog.h>
#include <gnome--/stock.h>
#include <libgnome/gnome-i18n.h>
#include <libgnomeui/gnome-app.h>
#include <libgnomeui/gnome-app-util.h>
#include <gnome--/app-helper.h>
#include <gnome--/types.h>

namespace Gtk {
  class MenuBar;
  class Toolbar;
}

namespace Gnome {
class App;
class App_Class;
}
namespace Gtk { Gnome::App *wrap (GnomeApp *o); }
namespace Gnome
{
class DockItem;
class Dock;
class App;

namespace App_Helpers {

class Progress
{
protected:
  GnomeAppProgressKey key_;
public:
  void set(gdouble percent);
  void done();
};

} // namespace App_Helpers


class App : public Gtk::Window
{

public:
  typedef App          CppObjectType;
  typedef App_Class    CppClassType;
  typedef GnomeApp           BaseObjectType;
  typedef GnomeAppClass      BaseClassType;

private:
  friend CppClassType;
  static CppClassType app_class;

  App(const App&);
  App& operator=(const App&); // not implemented

protected:
  void   initialize_class();
  explicit App(GnomeApp *castitem);

public:
  static GtkType get_type();
  GnomeApp* gtkobj()             { return (GnomeApp*)(gtkobject); }
  const GnomeApp* gtkobj() const { return (GnomeApp*)(gtkobject); }
  static bool isA(Gtk::Object *checkcast);

  // Hook for proxies
  static const char* const signal_names[];

  virtual ~App();

private:

public:



private:
  //: add() is not applicable
  //- Because a App is a compound widget, you would
  //- only use the set_content() function.
  void add(Gtk::Widget&);

public:
  App(const string &name);

  //: Create an application.
  //- appname is used to save preferences.
  //- title is for the App window.
  App(const string &appname,const string &title);

/*** From gnome-app.h ***/
  //: Set the menubar on the top.


  void set_menus(Gtk::MenuBar& menubar);

  //: Set the toolbar on the bottom.


  void set_toolbar(Gtk::Toolbar& toolbar);



  void set_statusbar(Gtk::Widget& statusbar);

  //: Sets the status bar with container.
  //- uses the given container widget rather than creating a new one.



  void set_statusbar_custom(Gtk::Container& container,Gtk::Widget& statusbar);

  //: Set the contents in the middle.


  void set_contents(Gtk::Widget& contents);

  void add_toolbar              (Gtk::Toolbar &toolbar,
                                 const string &name,
                                 GnomeDockItemBehavior behavior,
                                 GnomeDockPlacement placement,
                                 gint band_num,
                                 gint band_position,
                                 gint offset);

  void add_docked               (Gtk::Widget &widget,
                                 const string &name,
                                 GnomeDockItemBehavior behavior,
                                 GnomeDockPlacement placement,
                                 gint band_num,
                                 gint band_position,
                                 gint offset);

  void add_dock_item(DockItem& item,GnomeDockPlacement placement,gint band_num,gint band_position,gint offset);



  void enable_layout_config(gboolean enable);

  DockItem* get_dock_item_by_name (const string name);
  Gnome::Dock* get_dock() const;


/*** From gnome-app-helper.h ***/
// FIXME: this belongs with app-helpers not the app!
//   static void fill_menu         (Gtk::MenuShell &menu_shell,
//                                  UIInfoTree &menuinfo,
//                                  Gtk::AccelGroup &accel_group,
//                                  bool uline_accels,
//                                  gint pos);
   //: Create menus from UI.
   void create_menus             (const UI::Array &info);

   //: Adds hints to status bar.
   //- must be called if create_menus is used after status bar is
   //- established.
   void install_menu_hints();

   //: Create toolbar from UI.
   void create_toolbar           (const UI::Array &info);

// FIXME: This should be in gtk--.
//  WRAP_METHOD(
//    GtkWidget* gnome_app_find_menu_pos (GtkWidget*, const gchar*, gint*),
//    static Gtk::Widget* find_menu_pos(const Gtk::Widget& parent,
//						const string &path,
//						gint* pos));

// FIXME: insert/remove parts need to handle the UIInfo
//  WRAP_METHOD(void gnome_app_remove_menus(GnomeApp*, const gchar*, gint items),
//   void remove_menus(const string &path, gint items);
//   void insert_menus             (const string &path,
//                                  const UI::Array &menuinfo);
//
//   static void install_appbar_menu_hints    (const AppBar &app,
//                                             UIInfoTree &menuinfo);
//   static void install_statusbar_menu_hints (const Gtk::Statusbar &bar,
//                                             UIInfoTree &menuinfo);


/*** From gnome-app-util.h ***/

  //: Flash a status message on the status bar
  //-   If there isn't a status bar do nothing.  Intended for
  //-   trivial messages.


  void flash(const string& msg);


  // These functions create popup messages of various types attached
  // to this application.  The result is a managed widget which may
  // be 0.  (must check)  You do not have delete them; they will delete
  // when closed.

  //: Popup a status message (ok style).


  Gnome::Dialog* message(const string& msg);



  Gnome::Dialog* error(const string& msg);



  Gnome::Dialog* warning(const string& msg);

  //: Create a question dialog.
  Gnome::Dialog* question(const string& message,GnomeReplyCallback cb);
  //: Create a question dialog (modal).
  Gnome::Dialog* question_modal(const string& msg,GnomeReplyCallback cb);

  //: Create a okay/cancel dialog.
  Gnome::Dialog* ok_cancel(const string& msg,GnomeReplyCallback cb);
  //: Create a okay/cancel dialog (modal).
  Gnome::Dialog* ok_cancel_modal(const string& msg,GnomeReplyCallback cb);

  //: Create a request string dialog.
  Gnome::Dialog* request_string(const string &prompt,StringCallback cb);
  //: Create a request password dialog.
  Gnome::Dialog* request_password(const string &prompt,StringCallback cb);

  typedef App_Helpers::Progress Progress;
  //: Create a progress indicator.
  Progress progress(const string &description, Callback cancel=0);
  //: Create a progress indicator at intervals.
  Progress progress(const string &description, guint32 interval,
                    ProgressCallback percent, Callback cancel=0);

private:
  UI::Array menus_;
  UI::Array toolbars_;

public:

protected:
  // impl functions

};



}

#endif
